=begin
#ClickSend v3 API

# This is an official SDK for [ClickSend](https://clicksend.com)  Below you will find a current list of the available methods for clicksend.  *NOTE: You will need to create a free account to use the API. You can register [here](https://dashboard.clicksend.com/#/signup/step1/)..* 

OpenAPI spec version: 3.1
Contact: support@clicksend.com
Generated by: https://github.com/clicksend-api/clicksend-codegen.git
ClickSend Codegen version: 2.4.1-SNAPSHOT

=end

require 'uri'

module ClickSendClient
  class PostReturnAddressApi
    attr_accessor :api_client

    def initialize(api_client = ApiClient.default)
      @api_client = api_client
    end
    # Delete specific post return address
    # Delete specific post return address
    # @param return_address_id Return address ID
    # @param [Hash] opts the optional parameters
    # @return [String]
    def post_return_addresses_by_return_address_id_delete(return_address_id, opts = {})
      data, _status_code, _headers = post_return_addresses_by_return_address_id_delete_with_http_info(return_address_id, opts)
      data
    end

    # Delete specific post return address
    # Delete specific post return address
    # @param return_address_id Return address ID
    # @param [Hash] opts the optional parameters
    # @return [Array<(String, Fixnum, Hash)>] String data, response status code and response headers
    def post_return_addresses_by_return_address_id_delete_with_http_info(return_address_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PostReturnAddressApi.post_return_addresses_by_return_address_id_delete ...'
      end
      # verify the required parameter 'return_address_id' is set
      if @api_client.config.client_side_validation && return_address_id.nil?
        fail ArgumentError, "Missing the required parameter 'return_address_id' when calling PostReturnAddressApi.post_return_addresses_by_return_address_id_delete"
      end
      # resource path
      local_var_path = '/post/return-addresses/{return_address_id}'.sub('{' + 'return_address_id' + '}', return_address_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['BasicAuth']
      data, status_code, headers = @api_client.call_api(:DELETE, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'String')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PostReturnAddressApi#post_return_addresses_by_return_address_id_delete\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Get specific post return address
    # Get specific post return address
    # @param return_address_id Return address ID
    # @param [Hash] opts the optional parameters
    # @return [String]
    def post_return_addresses_by_return_address_id_get(return_address_id, opts = {})
      data, _status_code, _headers = post_return_addresses_by_return_address_id_get_with_http_info(return_address_id, opts)
      data
    end

    # Get specific post return address
    # Get specific post return address
    # @param return_address_id Return address ID
    # @param [Hash] opts the optional parameters
    # @return [Array<(String, Fixnum, Hash)>] String data, response status code and response headers
    def post_return_addresses_by_return_address_id_get_with_http_info(return_address_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PostReturnAddressApi.post_return_addresses_by_return_address_id_get ...'
      end
      # verify the required parameter 'return_address_id' is set
      if @api_client.config.client_side_validation && return_address_id.nil?
        fail ArgumentError, "Missing the required parameter 'return_address_id' when calling PostReturnAddressApi.post_return_addresses_by_return_address_id_get"
      end
      # resource path
      local_var_path = '/post/return-addresses/{return_address_id}'.sub('{' + 'return_address_id' + '}', return_address_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['BasicAuth']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'String')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PostReturnAddressApi#post_return_addresses_by_return_address_id_get\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Update post return address
    # Update post return address
    # @param return_address_id Return address ID
    # @param return_address Address model
    # @param [Hash] opts the optional parameters
    # @return [String]
    def post_return_addresses_by_return_address_id_put(return_address_id, return_address, opts = {})
      data, _status_code, _headers = post_return_addresses_by_return_address_id_put_with_http_info(return_address_id, return_address, opts)
      data
    end

    # Update post return address
    # Update post return address
    # @param return_address_id Return address ID
    # @param return_address Address model
    # @param [Hash] opts the optional parameters
    # @return [Array<(String, Fixnum, Hash)>] String data, response status code and response headers
    def post_return_addresses_by_return_address_id_put_with_http_info(return_address_id, return_address, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PostReturnAddressApi.post_return_addresses_by_return_address_id_put ...'
      end
      # verify the required parameter 'return_address_id' is set
      if @api_client.config.client_side_validation && return_address_id.nil?
        fail ArgumentError, "Missing the required parameter 'return_address_id' when calling PostReturnAddressApi.post_return_addresses_by_return_address_id_put"
      end
      # verify the required parameter 'return_address' is set
      if @api_client.config.client_side_validation && return_address.nil?
        fail ArgumentError, "Missing the required parameter 'return_address' when calling PostReturnAddressApi.post_return_addresses_by_return_address_id_put"
      end
      # resource path
      local_var_path = '/post/return-addresses/{return_address_id}'.sub('{' + 'return_address_id' + '}', return_address_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(return_address)
      auth_names = ['BasicAuth']
      data, status_code, headers = @api_client.call_api(:PUT, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'String')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PostReturnAddressApi#post_return_addresses_by_return_address_id_put\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Get list of post return addresses
    # Get list of post return addresses
    # @param [Hash] opts the optional parameters
    # @option opts [Integer] :page Page number (default to 1)
    # @option opts [Integer] :limit Number of records per page (default to 10)
    # @return [String]
    def post_return_addresses_get(opts = {})
      data, _status_code, _headers = post_return_addresses_get_with_http_info(opts)
      data
    end

    # Get list of post return addresses
    # Get list of post return addresses
    # @param [Hash] opts the optional parameters
    # @option opts [Integer] :page Page number
    # @option opts [Integer] :limit Number of records per page
    # @return [Array<(String, Fixnum, Hash)>] String data, response status code and response headers
    def post_return_addresses_get_with_http_info(opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PostReturnAddressApi.post_return_addresses_get ...'
      end
      if @api_client.config.client_side_validation && !opts[:'page'].nil? && opts[:'page'] < 1
        fail ArgumentError, 'invalid value for "opts[:"page"]" when calling PostReturnAddressApi.post_return_addresses_get, must be greater than or equal to 1.'
      end

      if @api_client.config.client_side_validation && !opts[:'limit'].nil? && opts[:'limit'] < 1
        fail ArgumentError, 'invalid value for "opts[:"limit"]" when calling PostReturnAddressApi.post_return_addresses_get, must be greater than or equal to 1.'
      end

      # resource path
      local_var_path = '/post/return-addresses'

      # query parameters
      query_params = {}
      query_params[:'page'] = opts[:'page'] if !opts[:'page'].nil?
      query_params[:'limit'] = opts[:'limit'] if !opts[:'limit'].nil?

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['BasicAuth']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'String')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PostReturnAddressApi#post_return_addresses_get\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Create post return address
    # Create post return address
    # @param return_address Address model
    # @param [Hash] opts the optional parameters
    # @return [String]
    def post_return_addresses_post(return_address, opts = {})
      data, _status_code, _headers = post_return_addresses_post_with_http_info(return_address, opts)
      data
    end

    # Create post return address
    # Create post return address
    # @param return_address Address model
    # @param [Hash] opts the optional parameters
    # @return [Array<(String, Fixnum, Hash)>] String data, response status code and response headers
    def post_return_addresses_post_with_http_info(return_address, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PostReturnAddressApi.post_return_addresses_post ...'
      end
      # verify the required parameter 'return_address' is set
      if @api_client.config.client_side_validation && return_address.nil?
        fail ArgumentError, "Missing the required parameter 'return_address' when calling PostReturnAddressApi.post_return_addresses_post"
      end
      # resource path
      local_var_path = '/post/return-addresses'

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(return_address)
      auth_names = ['BasicAuth']
      data, status_code, headers = @api_client.call_api(:POST, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'String')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PostReturnAddressApi#post_return_addresses_post\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
  end
end
